/*
** Delete A user from Training System
** Class: DeleteUser
** Author: Yuping Zhu
** Date: 04-05-1999
** Modified: 08-10-1999
**           Add delete warning
*/

package ascdb.users;

// import package oracle.html.* to generate dynamic HTML page
import oracle.html.*;

// import package java.sql to use JDBC
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;
import ascdb.pub.UserCheck;
import java.text.Collator;

public class DeleteUser extends HttpServlet {

     public static String me = null;

     public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	conf dbconf = new conf(req);
	me = req.getParameter("me");
	UserCheck u = new UserCheck(me);
	String uid = req.getParameter("uid");
	String opStr = req.getParameter("op");
	int op = 0;

  	try {
	   if (u.UserRole(1) != 0)
	   {
		out.println("You do not have this privilege!");
		return;
	   }

	   // Load the Oracle JDBC driver
	   Class.forName (dbconf.JdbcDriver);

	   // Connect to the database
	   Connection conn =
		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	   // Create a Statement
	   Statement stmt = conn.createStatement ();

	   // Retrieve user name from DB
	   ResultSet rset;
	   if (opStr == null) {
		rset = stmt.executeQuery("select last_nam, first_nam from users where oracle_uid= '" + uid + "'");
	       if (rset.next())
	       		out.print(DeleteWarning(uid,rset.getString(1),rset.getString(2)));
	   }
	   else { 
	     op = (new Integer(opStr)).intValue();
	     if (op == 1) {	   
	   	// Delete user's address record
	   	int rcount1 = stmt.executeUpdate("delete from addresses where id = '" + uid + "'");

	   	// Delete user's security record
	   	int rcount2 = stmt.executeUpdate("delete from db_users where db_id = '" + uid + "'");

	   	// Delete user's inctructor record
	   	int rcount3 = stmt.executeUpdate("delete from class_instructors where instructor_uid ='" + uid + "'");

	   	// Delete user's student record
	   	int rcount4 = stmt.executeUpdate("delete from class_students where student_uid = '" + uid + "'");

	   	// Delete User's record
	   	int rcount5 = stmt.executeUpdate("delete from users where oracle_uid = '" + uid + "'");
	   
	   	if ((rcount1 == 1) & (rcount2 == 1) & (rcount5 == 1))
			out.println("User: " + uid + " has been deleted!");
	   	else
			out.println("Can not delete user: " + uid + "!");
	     }
	     else if (op == 2)
		out.println("User: " + uid +" is not deleted!");  
	}
	}
	catch(ClassNotFoundException e) {
		out.println("Couldn't load database driver: " + e.getMessage());
           }
           catch (SQLException e) { 
		out.println(e.getMessage());
	   }
	   catch(Exception e) {
		out.println(e.getMessage());
	   }
     }

     public static HtmlPage DeleteWarning(String u, String lN, String fN) {
	// Creates an HtmlHead Object
           HtmlHead hd = new HtmlHead("User Delete Warning");
        
        // Create an HtmlBody Object
           HtmlBody bd = new HtmlBody();

        // Sets various attributes of HtmlBody
           bd.setBackgroundColor("#fffff2");
             
        // Creates an HtmlPage object using hd and bd
           HtmlPage hp = new HtmlPage(hd, bd);
	
	Collator cl = Collator.getInstance();

	Form frm1 = new Form("GET","ascdb.users.DeleteUser");
	frm1
	   .addItem(SimpleItem.LineBreak)
	   .addItem(new Hidden("me",me))
	   .addItem(new Hidden("uid",u))
	   .addItem(new Hidden("op","1"))
	   .addItem(new Submit("submit","Delete!"));
	
	Form frm2 = new Form("GET","ascdb.users.DeleteUser");
	frm2
	   .addItem(new Hidden("uid",u))  
	   .addItem(new Hidden("me",me))
	   .addItem(new Hidden("op","2"))
	   .addItem(new Submit("submit","No!"));

	bd
	  .addItem(new SimpleItem("User: " + u + " (" + fN + " " + lN + ") will be deleted from system ...!").setBold().setFontColor(Color.red))
	  .addItem(frm1.setCenter().setBold())
	  .addItem(frm2.setCenter().setBold());
        
  	return(hp);
    }	
}